/*--------------------------------------------------------------------------------------------
	6_integralkozelites_trapez_modszerrel.c 

*/

#include <stdio.h>
#include <math.h>

/* a vizsglt fggvny az x^3 + 1*/
double fgv(double x){
	return (x*x*x+1);	/* pow(x,3) + 1;*/
};

int trapez(double a, double b, int n, double *eredmeny)
{
	double sum, l;		/* a grbe alatti terletet s egy feloszts szlessgt fogja trolni*/

	l = (b-a)/n;		/* kiszmtjuk egy intervallum hosszt*/
	sum = 0;					

	for (int i=0; i < n; i++)
	{
	
		sum += ( (fgv(a + l*i) + fgv(a + l*(i+1)) ) /2) * l;	/* itt adjuk hozz az sszeghez a kvetkez*/
									/* intervallumhoz tartoz rtket*/
	}

	*eredmeny = sum;
	return 0;				/* visszatrnk*/
}


void main()
{
	double *eredmeny=new double;
	printf("Integralas trapez modszerrel , a fuggveny: y = x*x*x+1 \n");
	printf("Az intervallum : [-2,10] \n\n");
	trapez(-2,10,50,eredmeny);
    	printf("A megoldas : %lf ",*eredmeny);
	delete eredmeny;
	

}
