/*--------------------------------------------------------------------------------------------
	6_integralkozelites_teglalap_modszerrel.c

*/

#include <stdio.h>
#include <math.h>

/* a vizsglt fggvny az x^3 + 1*/
double fgv(double x){
	return (x*x*x+1);	/* pow(x,3) + 1;*/
};

int teglalap(double a, double b, int n, double *eredmeny)
{
	double sum, l;		/* a grbe alatti terletet s egy feloszts szlessgt fogja trolni*/
	l = (b-a)/n;		/* kiszmtjuk egy intervallum hosszt*/
	sum = 0;					

	for (int i=0; i < n; i++)
	{
		sum += (fgv(a + l*i)) * l;	/* itt adjuk hozz az sszeghez a kvetkez*/
						/* intervallumhoz tartoz rtket*/
	}

	*eredmeny = sum;
	return 1;				/* visszatrnk*/
}


void main()
{
	double *eredmeny=new double;
	printf("Integralas tglalap modszerrel , a fuggveny: y = x*x*x+1 \n");
	printf("Az intervallum : [-2,10] \n\n");
	teglalap(-2,10,50,eredmeny);
    	printf("A megoldas : %lf ",*eredmeny);
	delete eredmeny;
	

}
